package bismillah.rabiuls.tgetcontacts;

import java.util.ArrayList;

import android.content.ContentResolver;
import android.content.Context;
import android.database.Cursor;
import android.provider.ContactsContract;
import android.provider.ContactsContract.Contacts;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BA.ActivityObject;
import anywheresoftware.b4a.BA.Author;
import anywheresoftware.b4a.BA.Permissions;
import anywheresoftware.b4a.BA.ShortName;
import anywheresoftware.b4a.BA.Version;
import anywheresoftware.b4a.objects.collections.List;



@ShortName("TGetContacts")
@Permissions(values = {"android.permission.READ_CONTACTS"})
@Author("Rabiul")
@Version(1.0f)

public class TGetContacts {

    /**
    * Get all contacts in a List, Name and Phonenumber separated by newline.
    * 
    * Example:
    * 
    * 'Needs android.permission.READ_CONTACTS. Add the following line in Manifest file:
    * 'AddPermission("android.permission.READ_CONTACTS")
    * 
    * Dim TC As TGetContacts
    * Dim ContactList As List
    * Dim SelectedList As List
    * Dim result As List
 
    *  ContactList.Initialize
    *  SelectedList.Initialize
    *  
    *  ContactList.AddAll(TC.GetAllContacts) 'Retrieve all contacts. Each list item is a string of Name and Phonenumber - newline separated.
    *  result = InputMultiList(ContactList, "Select contact") 'Allow user to select necessary contact.
    *
    *  ListView1.Clear
    *
    *
    *  For i = 0 To result.Size - 1
    *     SelectedList.Add( ContactList.get(result.get(i)) ) 'SelectedList contains the user selected contact's name and number separated by "newline"
    *  Next
 
    *  For i = 0 To SelectedList.Size - 1
    *     ListView1.AddSingleLine(SelectedList.get(i)) 'Show the selected items.
    *  Next
    * 
    */


	public List GetAllContacts(){
		ArrayList<String> al = new ArrayList<String>();
		List list = new List();
		list.Initialize();
		String key;
		

		//BA context = getApplicationContext();
		//final ContentResolver resolver = getApplicationContext().getContentResolver();
		//ContentResolver cr = getContentResolver();
		Cursor phones =  BA.applicationContext.getApplicationContext().getContentResolver().query(
				ContactsContract.CommonDataKinds.Phone.CONTENT_URI,null,null,null,null);

		while (phones.moveToNext()) {
			String Name = phones
					.getString(phones
							.getColumnIndex(ContactsContract.CommonDataKinds.Phone.DISPLAY_NAME)); 
			String Number = phones
					.getString(phones
							.getColumnIndex(ContactsContract.CommonDataKinds.Phone.NUMBER));// ContactsContract.CommonDataKinds.Phone.NUMBER));

			// contactPhoneInfo.put(Name, Number);

			key = Name + "\n" + Number;
			
			// key = tmp.replaceAll("\\p{Cntrl}", "");
			
			al.add(key);
		}

		phones.close();
		list.setObject((java.util.ArrayList)al);
		return list;
		
	}

}
